# ที่มาและความสำคัญ

ปฏิเสธไม่ได้ว่าดนตรีเป็นหนึ่งในทักษะที่ได้รับความนิยม และวัฒนธรรมดนตรีนั้นแพร่หลายตั้งแต่ในฐานะงานอดิเรกของชนชั้นสูงในสมัยก่อน (เช่นการฟังดนตรีคลาสสิก) จนถึงรูปแบบประยุกต์ของดนตรี เช่นเกมเข้าจังหวะ นอกจากนี้ดนตรีมีส่วนช่วยในการเรียนรู้และฝึกสมาธิ

ผู้จัดทำสนใจสร้างคอนโทรลเลอร์สำหรับเกม Osu! ในโหมด Taiko ซึ่งเป็นเกมเข้าจังหวะอย่างง่าย ผู้เล่นจะต้องตีกลองคอนโทรลเลอร์ให้ถูกจังหวะตามที่แผนที่จังหวะเพลง (beatmap) กำหนด

# หลักการและวิธีการ

## คอนโทรลเลอร์เวอร์ชั่นแรก
ในการสร้างคอนโทรลเลอร์เวอร์ชั่นแรก ผู้สร้างใช้ฟอยล์ทำหน้าที่แทนสวิตช์ดิจิทัล สั่งงานไปยัง[บอร์ดแพรกทิคัม](https://www.cpe.ku.ac.th/~cpj/204223/slides/h4-mcu.pdf) ซึ่งเป็นบอร์ดไมโครคอนโทรลเลอร์ลักษณะคล้ายอาร์ดูโน พัฒนาโดยอ.ชัยพร ใจแก้ว จากห้องปฏิบัติการ iWing ภาควิชาวิศวกรรมคอมพิวเตอร์ คระวิศวกรรมศาสตร์ มหาวิทยาลัยเกษตรศาสตร์ โดยบอร์ดแพรกทิคัมจะทำหน้าที่เป็นอุปกรณ์ HID (กล่าวคือเป็นคีย์บอร์ด) เพื่อสั่งงานปุ่มไปยังเกม Osu! ให้กดปุ่มในเกมตามที่ผู้ใช้ตีกลอง

ปัญหาที่พบคือคอนโทรลเลอร์เวอร์ชั่นแรกจำเป็นต้องมีสายต่อระหว่างไม้กลองและตัวกลอง ทำให้การสั่งงานไม่สะดวกสบาย ผู้จัดทำตัดสินใจเปลี่ยนไปใช้เปียโซอิเล็กทริกในการรับการสั่น

## คอนโทรลเลอร์เวอร์ชั่นที่สอง
คอนโทรลเลอร์เวอร์ชั่นที่สองเปลี่ยนไปใช้เซนเซอร์เปียโซอิเล็กทริกในการรับค่าการสั่นสะเทือนเป็นสัญญาณแอนะล็อกตั้งแต่ 1-1024 และบอร์ดแพรกทิคัมทำหน้าที่ตัดสินใจว่าควรส่งการกดปุ่มใด

ปัญหาที่เกิดขึ้นคือ การสั่นของเซนเซอร์เปียโซอิเล็กทริกไม่สามารถคาดเดาได้เป็นรูปแบบที่แน่นอน ผู้จัดทำต้องหาวิธีการตัดสินใจใหม่ให้กับตัวกลอง

## คอนโทรลเลอร์เวอร์ชั่นที่สาม
คอนโทรลเลอร์เวอร์ชั่นที่สามนั้นใช้ตัวอุปกรณ์เหมือนกับเวอร์ชั่นที่สองทุกประการ แต่ต่อเพิ่มตัวแปลงพอร์ทอนุกรม (serial monitor) ขึ้นมา และใช้วิธีการให้บอร์ดส่งค่าดิบ (raw value) ที่อ่านจากเซนเซอร์ได้ขึ้นมาแทน

เมื่อบอร์ดส่งค่ามา สคริปต์ภาษาไพธอนจะประมวลผลปุ่มด้วยเทคนิก Machine Learning โดยไลบรารี่ `sklearn` ซึ่งใช้โมเดล support vector machine (SVM) ที่ฝึก (train) จากประวัติแรงสั่นจากการตีกลองทั้งหมดประมาณ 600 ครั้ง เมื่อประมวลผลเสร็จจะส่งปุ่มกดด้วยไลบรารี่ `pyautogui` ไปยังเกม Osu! ต่อไป 